#!/usr/bin/env python


try:
    import pygtk
    pygtk.require("2.0")
except Exception, detail:
    print "You do not have a recent version of GTK"

try:
    import os
    import sys
    import commands
    import gtk
    import gtk.glade
    import gettext
    import string
    import Parser_LPMT
    import Check_LPMT
except Exception, detail:
    print "You do not have the required dependencies"

# i18n
gettext.install("lpmt", "/usr/share/lpmt/locale")
#gettext.install("lpmt", "../../share/lpmt/locale")

# i18n for menu item
menuName = _("Log Parser Management Tool")
menuComment = _("Make a statistics of log")

''' The main class of the app '''
class LPMT:

    ''' New Log Parser Management Tool '''
    def __init__(self):
        self.glade = '/usr/lib/lpmt/lpmt.glade'
        #self.glade = 'lpmt.glade'
        self.wTree = gtk.glade.XML(self.glade, 'main_window')

        # handle command line filenames
        if(len(sys.argv) > 1):
            print "usage: " + sys.argv[0]
            sys.exit(1)
        #parser for logs
        parser = Parser_LPMT.Parser_LPMT()
        self.check_parser = Check_LPMT.Check_LPMT()

        #flag for menu,0 for menu_view,1 for menu_analyze
        self.flag_menu = 0

        # info of wtmp
        self.wtmp_year = []
        self.wtmp_content = []
        self.wtmp_content_formated = []
        self.time_list = []
        self.times_for_years = []

        #item number
        self.number_for_wtmp = 0
        self.number_for_times = 0
        self.number_for_boot = 0
        self.number_for_kern = 0
        self.number_for_dpkg = 0
        self.number_for_sys = 0
        self.number_for_auth = 0
        self.number_for_alter = 0
        self.number_for_ufw = 0
        self.number_for_cups = 0
        self.number_for_dmesg = 0
        self.number_for_fail = 0
        self.number_for_xorg = 0

        #item count
        self.count_for_wtmp = 0
        self.count_for_times = 0
        self.count_for_boot = 0
        self.count_for_kern = 0
        self.count_for_dpkg = 0
        self.count_for_sys = 0
        self.count_for_auth = 0
        self.count_for_alter = 0
        self.count_for_ufw = 0
        self.count_for_cups = 0
        self.count_for_dmesg = 0
        self.count_for_fail = 0
        self.count_for_xorg = 0

        #load flag
        self.load_boot_flag = 0
        self.load_kern_flag = 0
        self.load_dpkg_flag = 0
        self.load_sys_flag = 0
        self.load_auth_flag = 0
        self.load_alter_flag = 0
        self.load_ufw_flag = 0
        self.load_cups_flag = 0
        self.load_dmesg_flag = 0
        self.load_fail_flag = 0
        self.load_xorg_flag = 0

        #used for pages turning
        self.twopage_count1 = 64
        self.twopage_count2 = 64
        self.item_count1 = 32
        self.item_count2 = 32

        self.twopage_count = self.twopage_count1
        self.items_one_page = self.item_count1

        #list loaded into user interface 
        self.load_wtmp_list = []
        self.load_times_list = []
        self.load_boot_list = []
        self.load_kern_list = []
        self.load_dpkg_list = []
        self.load_sys_list = []
        self.load_auth_list = []
        self.load_alter_list = []
        self.load_ufw_list = []
        self.load_cups_list = []
        self.load_dmesg_list = []
        self.load_fail_list = []
        self.load_xorg_list = []

        #keyword for every list
        self.keyword_wtmp = ''
        self.keyword_times = ''
        self.keyword_boot = ''
        self.keyword_kern = ''
        self.keyword_dpkg = ''
        self.keyword_sys = ''
        self.keyword_auth = ''
        self.keyword_alter = ''
        self.keyword_ufw = ''
        self.keyword_cups = ''
        self.keyword_dmesg = ''
        self.keyword_fail = ''
        self.keyword_xorg = ''

        #current year and month
        self.year_for_wtmp = 0
        self.month_for_wtmp = 0
        self.year_for_times = 0
        self.month_for_times = 0

        #page0
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=3)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_all").append_column(column)

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=3)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_all").append_column(column)

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=3)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_all").append_column(column)

        #page1
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Year"), ren, background=4)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_times").append_column(column)
        self.wTree.get_widget("treeview_times").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Month"), ren, background=4)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_times").append_column(column)
        self.wTree.get_widget("treeview_times").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Reboot times"), ren, background=4)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_times").append_column(column)
        self.wTree.get_widget("treeview_times").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Shutdown times"), ren, background=4)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_times").append_column(column)
        self.wTree.get_widget("treeview_times").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page2
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Load time"), ren, background=2)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_dmesg").append_column(column)
        self.wTree.get_widget("treeview_dmesg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Load information"), ren, background=2)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_dmesg").append_column(column)
        self.wTree.get_widget("treeview_dmesg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page3
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=5)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_auth").append_column(column)
        self.wTree.get_widget("treeview_auth").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=5)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_auth").append_column(column)
        self.wTree.get_widget("treeview_auth").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=5)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_auth").append_column(column)
        self.wTree.get_widget("treeview_auth").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=5)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_auth").append_column(column)
        self.wTree.get_widget("treeview_auth").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=5)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_auth").append_column(column)
        self.wTree.get_widget("treeview_auth").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page4
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=5)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_sys").append_column(column)
        self.wTree.get_widget("treeview_sys").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=5)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_sys").append_column(column)
        self.wTree.get_widget("treeview_sys").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=5)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_sys").append_column(column)
        self.wTree.get_widget("treeview_sys").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=5)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_sys").append_column(column)
        self.wTree.get_widget("treeview_sys").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=5)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_sys").append_column(column)
        self.wTree.get_widget("treeview_sys").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page5
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=2)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_boot").append_column(column)
        self.wTree.get_widget("treeview_boot").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=2)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_boot").append_column(column)
        self.wTree.get_widget("treeview_boot").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page6
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=4)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_dpkg").append_column(column)
        self.wTree.get_widget("treeview_dpkg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=4)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_dpkg").append_column(column)
        self.wTree.get_widget("treeview_dpkg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("State"), ren, background=4)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_dpkg").append_column(column)
        self.wTree.get_widget("treeview_dpkg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Package"), ren, background=4)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_dpkg").append_column(column)
        self.wTree.get_widget("treeview_dpkg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page7
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=4)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_kern").append_column(column)
        self.wTree.get_widget("treeview_kern").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=4)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_kern").append_column(column)
        self.wTree.get_widget("treeview_kern").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=4)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_kern").append_column(column)
        self.wTree.get_widget("treeview_kern").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=4)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_kern").append_column(column)
        self.wTree.get_widget("treeview_kern").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page8
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=3)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_alter").append_column(column)
        self.wTree.get_widget("treeview_alter").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=3)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_alter").append_column(column)
        self.wTree.get_widget("treeview_alter").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=3)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_alter").append_column(column)
        self.wTree.get_widget("treeview_alter").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page9
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=6)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=6)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=6)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("User"), ren, background=6)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=6)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=6)
        column.add_attribute(ren, "text", 5)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page10
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Ufwdate"), ren, background=14)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Ufwtime"), ren, background=14)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Ufwhost"), ren, background=14)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Incard"), ren, background=14)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Outcard"), ren, background=14)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("MAC"), ren, background=14)
        column.add_attribute(ren, "text", 5)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("SRC"), ren, background=14)
        column.add_attribute(ren, "text", 6)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("DEST"), ren, background=14)
        column.add_attribute(ren, "text", 7)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("LEN"), ren, background=14)
        column.add_attribute(ren, "text", 8)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("ID"), ren, background=14)
        column.add_attribute(ren, "text", 9)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("PROTO"), ren, background=14)
        column.add_attribute(ren, "text", 10)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("SPT"), ren, background=14)
        column.add_attribute(ren, "text", 11)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("DPT"), ren, background=14)
        column.add_attribute(ren, "text", 12)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("WINDOW"), ren, background=14)
        column.add_attribute(ren, "text", 13)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_ufw").append_column(column)
        self.wTree.get_widget("treeview_ufw").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page11
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("User"), ren, background=4)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_fail").append_column(column)
        self.wTree.get_widget("treeview_fail").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Fail times"), ren, background=4)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_fail").append_column(column)
        self.wTree.get_widget("treeview_fail").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Fail date"), ren, background=4)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_fail").append_column(column)
        self.wTree.get_widget("treeview_fail").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Fail time"), ren, background=4)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_fail").append_column(column)
        self.wTree.get_widget("treeview_fail").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page12
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Load time"), ren, background=2)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_xorg").append_column(column)
        self.wTree.get_widget("treeview_xorg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=2)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_xorg").append_column(column)
        self.wTree.get_widget("treeview_xorg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        # nav buttons
        self.wTree.get_widget("button_lastpage").connect("clicked", self.last_callback)
        self.wTree.get_widget("button_nextpage").connect("clicked", self.next_callback)
        self.wTree.get_widget("button_jumpto").connect("clicked", self.jumppage_callback)
        self.wTree.get_widget("button_search").connect("clicked", self.filter_statistics_callback)
        self.wTree.get_widget("button_close").connect("clicked", self.cancel_callback)

        #entry
        self.wTree.get_widget("entry_keyword").connect("activate", self.filter_statistics_callback)
        self.wTree.get_widget("entry_page").connect("activate", self.jumppage_callback)

        self.wTree.get_widget("main_window").connect("destroy", self.cancel_callback)
        self.wTree.get_widget("main_window").set_title(_("Log Parser Management Tool"))
        self.wTree.get_widget("main_window").show()

        #menuitems and labels
        time_item = gtk.MenuItem(_("Last search"))
        time_item.show()
        self.wTree.get_widget("menu_view").append(time_item)
        time_item.connect("activate", self.change_notebook)

        dmesg_item = gtk.MenuItem(_("Dmesg statistics"))
        dmesg_item.show()
        self.wTree.get_widget("menu_view").append(dmesg_item)
        dmesg_item.connect("activate", self.change_notebook)

        auth_item = gtk.MenuItem(_("Auth statistics"))
        auth_item.show()
        self.wTree.get_widget("menu_view").append(auth_item)
        auth_item.connect("activate", self.change_notebook)

        sys_item = gtk.MenuItem(_("Sys statistics"))
        sys_item.show()
        self.wTree.get_widget("menu_view").append(sys_item)
        sys_item.connect("activate", self.change_notebook)

        boot_item = gtk.MenuItem(_("Boot statistics"))
        boot_item.show()
        self.wTree.get_widget("menu_view").append(boot_item)
        boot_item.connect("activate", self.change_notebook)

        dpkg_item = gtk.MenuItem(_("Dpkg statistics"))
        dpkg_item.show()
        self.wTree.get_widget("menu_view").append(dpkg_item)
        dpkg_item.connect("activate", self.change_notebook)

        kern_item = gtk.MenuItem(_("Kern statistics"))
        kern_item.show()
        self.wTree.get_widget("menu_view").append(kern_item)
        kern_item.connect("activate", self.change_notebook)

        alt_item = gtk.MenuItem(_("Alternative statistics"))
        alt_item.show()
        self.wTree.get_widget("menu_view").append(alt_item)
        alt_item.connect("activate", self.change_notebook)

        cups_item = gtk.MenuItem(_("Cups statistics"))
        cups_item.show()
        self.wTree.get_widget("menu_view").append(cups_item)
        cups_item.connect("activate", self.change_notebook)

        ufw_item = gtk.MenuItem(_("Ufw statistics"))
        ufw_item.show()
        self.wTree.get_widget("menu_view").append(ufw_item)
        ufw_item.connect("activate", self.change_notebook)

        fail_item = gtk.MenuItem(_("Fail statistics"))
        fail_item.show()
        self.wTree.get_widget("menu_view").append(fail_item)
        fail_item.connect("activate", self.change_notebook)

        xorg_item = gtk.MenuItem(_("Xorg statistics"))
        xorg_item.show()
        self.wTree.get_widget("menu_view").append(xorg_item)
        xorg_item.connect("activate", self.change_notebook)

        times_item = gtk.MenuItem(_("Times statistics"))
        times_item.show()
        self.wTree.get_widget("menu_analyze").append(times_item)
        times_item.connect("activate", self.change_notebook)

        self.wTree.get_widget("imagemenuitem_help").connect("activate", self.about_callback)

        self.wTree.get_widget("label_logtitle").set_text(_("Last search"))
        self.wTree.get_widget("label_year").set_text(_("Keyword year"))
        self.wTree.get_widget("label_month").set_text(_("Keyword month"))
        self.wTree.get_widget("label_keyword").set_text(_("Keyword for search"))
        self.wTree.get_widget("label_jumpto").set_text(_("Jump to"))
        self.wTree.get_widget("label_page").set_text(_("page"))
        self.wTree.get_widget("button_search").set_label(_("Search"))

        comps = gtk.ListStore(str)
        comps.append([None])
        self.get_info("/var/log/wtmp")
        for year in self.wtmp_year:
            comps.append([year])
        self.wTree.get_widget("combobox_year").set_model(comps)
        self.wTree.get_widget("combobox_year").set_active(0)
        self.wTree.get_widget("combobox_year").connect("changed", self.filter_statistics_callback)

        comps = gtk.ListStore(str)
        comps.append([None])
        comps.append(["1"])
        comps.append(["2"])
        comps.append(["3"])
        comps.append(["4"])
        comps.append(["5"])
        comps.append(["6"])
        comps.append(["7"])
        comps.append(["8"])
        comps.append(["9"])
        comps.append(["10"])
        comps.append(["11"])
        comps.append(["12"])

        self.wTree.get_widget("combobox_month").set_model(comps)
        self.wTree.get_widget("combobox_month").set_active(0)
        self.wTree.get_widget("combobox_month").connect("changed", self.filter_statistics_callback)

        #get information of wtmp
        self.format_wtmp_content()
        self.get_times()
        self.load_wtmp_list = self.time_list[:]
        self.load_times_list = self.times_for_years[:]

        #initialize times statistics treeview
        self.load_times(f=1, start = 0, end = 0)

        #initialize time statistics treeview with the rescent record--24 items
        self.load_wtmp(f=1, start = 0, end = 0)

        #initialize page label
        self.update_pagelabel(self.number_for_wtmp ,self.count_for_wtmp)

        #initialize two button
        self.count_for_wtmp = len(self.load_wtmp_list)
        if self.count_for_wtmp <= self.items_one_page:
            self.wTree.get_widget("button_nextpage").hide()
        self.wTree.get_widget("button_lastpage").hide()

        #get information of boot.log
        self.bootlist = parser.parser_all_boot_log()
        self.count_for_boot = len(self.bootlist)
        self.load_boot_list = self.bootlist[:]

        #get information of kern.log
        self.kernlist = parser.parser_all_kern_log()
        self.count_for_kern = len(self.kernlist)
        self.load_kern_list = self.kernlist[:]

        #get information of dpkg.log
        self.dpkglist = parser.parser_all_dpkg_log()
        self.count_for_dpkg = len(self.dpkglist)
        self.load_dpkg_list = self.dpkglist[:]

        #get information of syslog
        self.syslist = parser.parser_all_sys_log()
        self.count_for_sys = len(self.syslist)
        self.load_sys_list = self.syslist[:]

        #get information of auth.log
        self.authlist = parser.parser_all_auth_log()
        self.count_for_auth = len(self.authlist)
        self.load_auth_list = self.authlist[:]

        #get information of alternatives.log
        self.alterlist = parser.parser_all_alter_log()
        self.count_for_alter = len(self.alterlist)
        self.load_alter_list = self.alterlist[:]

        #get information of ufw.log
        self.ufwlist = parser.parser_all_ufw_log()
        self.count_for_ufw = len(self.ufwlist)
        self.load_ufw_list = self.ufwlist[:]

        #get information of cups
        self.cupslist = parser.parser_all_cups_log()
        self.count_for_cups = len(self.cupslist)
        self.load_cups_list = self.cupslist[:]

        #get information of dmesg
        self.dmesglist = parser.parser_all_dmesg_log()
        self.count_for_dmesg = len(self.dmesglist)
        self.load_dmesg_list = self.dmesglist[:]

        #get information of faillog
        self.faillist = parser.parser_all_fail_log()
        self.count_for_fail = len(self.faillist)
        self.load_fail_list = self.faillist[:]

        #get information of xorglog
        self.xorglist = parser.parser_all_xorg_log()
        self.count_for_xorg = len(self.xorglist)
        self.load_xorg_list = self.xorglist[:]

    ''' Get output of os command '''
    def execCmd(self,cmd):
        try:
            r = os.popen(cmd)
            lines = r.readlines()
            r.close()
        except Exception, detail:
            print detail
        return lines

    ''' Get shutdown and reboot times for each year and each month'''
    def get_times(self):
        for year in self.wtmp_year:
            reboot_shutdown_count = [[0,0],[0,0],[0,0],
                                     [0,0],[0,0],[0,0],
                                     [0,0],[0,0],[0,0],
                                     [0,0],[0,0],[0,0]]
            for content in self.wtmp_content_formated:
                if content.get('year') == year:
                    if content.get('action') == 'reboot':
                        reboot_shutdown_count[string.atoi(content.get('month'))-1][0] = 1 + reboot_shutdown_count[string.atoi(content.get('month'))-1][0]
                    else:
                        reboot_shutdown_count[string.atoi(content.get('month'))-1][1] = 1 + reboot_shutdown_count[string.atoi(content.get('month'))-1][1]
            for month in [0,1,2,3,4,5,6,7,8,9,10,11]:
                if reboot_shutdown_count[month][0] + reboot_shutdown_count[month][1] != 0:
                    self.count_for_times += 1
                    self.times_for_years.append({'year':year, 'month':str(month+1), 'reboot':str(reboot_shutdown_count[month][0]), 'shutdown':str(reboot_shutdown_count[month][1])})

    ''' Get information of wtmp '''
    def get_info(self,logname):
        if logname == "/var/log/wtmp":
            tmpname = logname
            n = 0
            while True:
                if os.path.exists(tmpname):
                    lines = self.execCmd("last -x -F -f " + tmpname)
                    self.wtmp_content.append(lines)
                    yearline = lines[-1]
                    year = yearline.rstrip("\n").split()[-1]
                    self.wtmp_year.append(year)
                else:
                    break
                n += 1
                tmpname = logname + '.' + str(n)
            tmp_year = []
            for year in list(set(self.wtmp_year)):
                tmp_year.append(year)
            self.wtmp_year = tmp_year

    '''Format wtmp's content'''
    def format_wtmp_content(self):
        for content in self.wtmp_content:
            for c in content:
                if c.find('reboot') >= 0 or c.find('shutdown') >= 0:
                    content_line = c.split()
                    if content_line[5] == 'Jan':
                        month = '1'
                    elif content_line[5] == 'Feb':
                        month = '2'
                    elif content_line[5] == 'Mar':
                        month = '3'
                    elif content_line[5] == 'Apr':
                        month = '4'
                    elif content_line[5] == 'May':
                        month = '5'
                    elif content_line[5] == 'Jun':
                        month = '6'
                    elif content_line[5] == 'Jul':
                        month = '7'
                    elif content_line[5] == 'Aug':
                        month = '8'
                    elif content_line[5] == 'Sep':
                        month = '9'
                    elif content_line[5] == 'Oct':
                        month = '10'
                    elif content_line[5] == 'Nov':
                        month = '11'
                    else:
                        month = '12'
                    self.wtmp_content_formated.append({'year':content_line[8],'month':month,'day':content_line[6],'time':content_line[7],'action':content_line[0]})
                    self.time_list.append({'date':content_line[8]+'-'+month+'-'+content_line[6],'time':content_line[7],'action':content_line[0]})
        self.count_for_wtmp = len(self.time_list)


    ''' Cancel clicked '''
    def cancel_callback(self, widget):
        # just quit :)
        gtk.main_quit()

    ''' show the pretty aboutbox. '''
    def about_callback(self, w):
        dlg = gtk.AboutDialog()
        dlg.set_title(_("About"))
        dlg.set_program_name(_("Log Parser Management Tool"))
        try:
            '''
            h = open('/usr/share/common-licenses/GPL','r')
            s = h.readlines()
            gpl = ""
            for line in s:
                gpl += line
            h.close()
            '''
            gpl = "\xe7\x89\x88\xe6\x9d\x83\xe6\x89\x80\xe6\x9c\x89:\xe4\xb8\xad\xe7\xa7\x91\xe6\x96\xb9\xe5\xbe\xb7"
            dlg.set_license(gpl)
        except Exception, detail:
            print detail
        try:
            version = commands.getoutput("/usr/lib/lpmt/version.py lpmt")
            dlg.set_version(version)
        except Exception, detail:
            print detail

        dlg.set_authors(["Dayong Wang <dayong@nfschina.com>", "Zhengxian Shi <zhengxian@nfschina.com>"])
        dlg.set_icon_from_file("/usr/lib/lpmt/icon.png")
        dlg.set_logo(gtk.gdk.pixbuf_new_from_file("/usr/lib/lpmt/icon.svg"))
        def close(w, res):
            if res == gtk.RESPONSE_CANCEL:
                w.hide()
        dlg.connect("response", close)
        dlg.show()

    def abt_resp(self, w, r):
        if r == gtk.RESPONSE_CANCEL:
            w.hide()

    ''' load shutdown and reboot time into gtk '''
    def load_wtmp(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str)
        wtmp_color_flag = 0
        if f == 1:
            for content in self.load_wtmp_list[start:]:
                if self.number_for_wtmp >= tmpstart + self.items_one_page:
                    break
                if wtmp_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),_(content.get('action')),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),_(content.get('action')),'#80FFFF'])
                wtmp_color_flag = ~wtmp_color_flag
                self.number_for_wtmp += 1
        else:
            for content in self.load_wtmp_list[start:end]:
                if wtmp_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),_(content.get('action')),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),_(content.get('action')),'#80FFFF'])
                wtmp_color_flag = ~wtmp_color_flag
        self.wTree.get_widget("treeview_all").set_model(model)

    ''' load shutdown and reboot times into gtk '''
    def load_times(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str)
        times_color_flag = 0
        if f == 1:
            for l in self.load_times_list[start:]:
                if self.number_for_times >= tmpstart + self.items_one_page:
                    break
                if times_color_flag == 0:
                    model.append([l.get('year'),l.get('month'),l.get('reboot'),l.get('shutdown'),'#C9C9C9'])
                else:
                    model.append([l.get('year'),l.get('month'),l.get('reboot'),l.get('shutdown'),'#80FFFF'])
                times_color_flag = ~times_color_flag
                self.number_for_times += 1
        else:
            for l in self.load_time_list[start:end]:
                if times_color_flag == 0:
                    model.append([l.get('year'),l.get('month'),l.get('reboot'),l.get('shutdown'),'#C9C9C9'])
                else:
                    model.append([l.get('year'),l.get('month'),l.get('reboot'),l.get('shutdown'),'#80FFFF'])
                times_color_flag = ~times_color_flag
                self.number_for_times += 1
        self.wTree.get_widget("treeview_times").set_model(model)

    ''' load boot information into gtk '''
    def load_bootlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str)
        boot_color_flag = 0
        if f == 1:
            for content in self.load_boot_list[start:]:
                if self.number_for_boot >= tmpstart + self.items_one_page:
                    break
                if boot_color_flag == 0:
                    model.append([content.get('doit'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('doit'),content.get('msg'),'#80FFFF'])
                boot_color_flag = ~boot_color_flag
                self.number_for_boot += 1
        else:
            for content in self.load_boot_list[start:end]:
                if boot_color_flag == 0:
                    model.append([content.get('doit'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('doit'),content.get('msg'),'#80FFFF'])
                boot_color_flag = ~boot_color_flag
        self.wTree.get_widget("treeview_boot").set_model(model)

    ''' load kern information into gtk '''
    def load_kernlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str)
        kern_color_flag = 0
        if f == 1:
            for content in self.load_kern_list[start:]:
                if self.number_for_kern >= tmpstart + self.items_one_page:
                    break
                if kern_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('msg'),'#80FFFF'])
                kern_color_flag = ~kern_color_flag
                self.number_for_kern += 1
        else:
            for content in self.load_kern_list[start:end]:
                if kern_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('msg'),'#80FFFF'])
                kern_color_flag = ~kern_color_flag
        self.wTree.get_widget("treeview_kern").set_model(model)

    ''' load dpkg information into gtk '''
    def load_dpkglist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str)
        dpkg_color_flag = 0
        if f == 1:
            for content in self.load_dpkg_list[start:]:
                if self.number_for_dpkg >= tmpstart + self.items_one_page:
                    break
                if dpkg_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('status'),content.get('pkg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('status'),content.get('pkg'),'#80FFFF'])
                dpkg_color_flag = ~dpkg_color_flag
                self.number_for_dpkg += 1
        else:
            for content in self.load_dpkg_list[start:end]:
                if dpkg_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('status'),content.get('pkg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('status'),content.get('pkg'),'#80FFFF'])
                dpkg_color_flag = ~dpkg_color_flag
        self.wTree.get_widget("treeview_dpkg").set_model(model)

    ''' load sys information into gtk '''
    def load_syslist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str)
        sys_color_flag = 0
        if f == 1:
            for content in self.load_sys_list[start:]:
                if self.number_for_sys >= tmpstart + self.items_one_page:
                    break
                if sys_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#80FFFF'])
                sys_color_flag = ~sys_color_flag
                self.number_for_sys += 1
        else:
            for content in self.load_sys_list[start:end]:
                if sys_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#80FFFF'])
                sys_color_flag = ~sys_color_flag
        self.wTree.get_widget("treeview_sys").set_model(model)

    ''' load auth information into gtk '''
    def load_authlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str)
        auth_color_flag = 0
        if f == 1:
            for content in self.load_auth_list[start:]:
                if self.number_for_auth >= tmpstart + self.items_one_page:
                    break
                if auth_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#80FFFF'])
                auth_color_flag = ~auth_color_flag
                self.number_for_auth += 1
        else:
            for content in self.load_auth_list[start:end]:
                if auth_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#80FFFF'])
                auth_color_flag = ~auth_color_flag
        self.wTree.get_widget("treeview_auth").set_model(model)

    ''' load alternatives information into gtk '''
    def load_alterlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str)
        alter_color_flag = 0
        if f == 1:
            for content in self.load_alter_list[start:]:
                if self.number_for_alter >= tmpstart + self.items_one_page:
                    break
                if alter_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('msg'),'#80FFFF'])
                alter_color_flag = ~alter_color_flag
                self.number_for_alter += 1
        else:
            for content in self.load_alter_list[start:end]:
                if alter_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('msg'),'#80FFFF'])
                alter_color_flag = ~alter_color_flag
        self.wTree.get_widget("treeview_alter").set_model(model)

    ''' load ufw information into gtk '''
    def load_ufwlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, 
                              str, str, str, str, 
                              str, str, str, str, 
                              str, str, str)
        ufw_color_flag = 0
        if f == 1:
            for content in self.load_ufw_list[start:]:
                if self.number_for_ufw >= tmpstart + self.items_one_page:
                    break
                if ufw_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('incard'),
                                  content.get('outcard'),content.get('mac'),content.get('src'),content.get('dest'),
                                  content.get('len'),content.get('id'),content.get('proto'),content.get('spt'),
                                  content.get('dpt'),content.get('window'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('incard'),
                                  content.get('outcard'),content.get('mac'),content.get('src'),content.get('dest'),
                                  content.get('len'),content.get('id'),content.get('proto'),content.get('spt'),
                                  content.get('dpt'),content.get('window'),'#80FFFF'])
                ufw_color_flag = ~ufw_color_flag
                self.number_for_ufw += 1
        else:
            for content in self.load_ufw_list[start:end]:
                if ufw_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('incard'),
                                  content.get('outcard'),content.get('mac'),content.get('src'),content.get('dest'),
                                  content.get('len'),content.get('id'),content.get('proto'),content.get('spt'),
                                  content.get('dpt'),content.get('window'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('incard'),
                                  content.get('outcard'),content.get('mac'),content.get('src'),content.get('dest'),
                                  content.get('len'),content.get('id'),content.get('proto'),content.get('spt'),
                                  content.get('dpt'),content.get('window'),'#80FFFF'])
                ufw_color_flag = ~ufw_color_flag
        self.wTree.get_widget("treeview_ufw").set_model(model)

    ''' load cups information into gtk '''
    def load_cupslist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str, str)
        cups_color_flag = 0
        if f == 1:
            for content in self.load_cups_list[start:]:
                if self.number_for_cups >= tmpstart + self.items_one_page:
                    break
                if cups_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg'),'#80FFFF'])
                cups_color_flag = ~cups_color_flag
                self.number_for_cups += 1
        else:
            for content in self.load_cups_list[start:end]:
                if cups_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg'),'#80FFFF'])
                cups_color_flag = ~cups_color_flag
        self.wTree.get_widget("treeview_cups").set_model(model)

    ''' load dmesg information into gtk '''
    def load_dmesglist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str,str)
        dmesg_color_flag = 0
        if f == 1:
            for content in self.load_dmesg_list[start:]:
                if self.number_for_dmesg >= tmpstart + self.items_one_page:
                    break
                if dmesg_color_flag == 0:
                    model.append([content.get('loadt'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('loadt'),content.get('msg'),'#80FFFF'])
                dmesg_color_flag = ~dmesg_color_flag
                self.number_for_dmesg += 1
        else:
            for content in self.load_dmesg_list[start:end]:
                if dmesg_color_flag == 0:
                    model.append([content.get('loadt'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('loadt'),content.get('msg'),'#80FFFF'])
                dmesg_color_flag = ~dmesg_color_flag
        self.wTree.get_widget("treeview_dmesg").set_model(model)

    ''' load fail information into gtk '''
    def load_faillist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str)
        fail_color_flag = 0
        if f == 1:
            for content in self.load_fail_list[start:]:
                if self.number_for_fail >= tmpstart + self.items_one_page:
                    break
                if fail_color_flag == 0:
                    model.append([content.get('user'),content.get('ftimes'),content.get('date'),content.get('time'),'#C9C9C9'])
                else:
                    model.append([content.get('user'),content.get('ftimes'),content.get('date'),content.get('time'),'#80FFFF'])
                fail_color_flag = ~fail_color_flag
                self.number_for_fail += 1
        else:
            for content in self.load_fail_list[start:end]:
                if fail_color_flag == 0:
                    model.append([content.get('user'),content.get('ftimes'),content.get('date'),content.get('time'),'#C9C9C9'])
                else:
                    model.append([content.get('user'),content.get('ftimes'),content.get('date'),content.get('time'),'#80FFFF'])
                fail_color_flag = ~fail_color_flag
        self.wTree.get_widget("treeview_fail").set_model(model)

    ''' load xorg information into gtk '''
    def load_xorglist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str)
        xorg_color_flag = 0
        if f == 1:
            for content in self.load_xorg_list[start:]:
                if self.number_for_xorg >= tmpstart + self.items_one_page:
                    break
                if xorg_color_flag == 0:
                    model.append([content.get('loadt'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('loadt'),content.get('msg'),'#80FFFF'])
                xorg_color_flag = ~xorg_color_flag
                self.number_for_xorg += 1
        else:
            for content in self.load_xorg_list[start:end]:
                if xorg_color_flag == 0:
                    model.append([content.get('loadt'),content.get('msg'),'#C9C9C9'])
                else:
                    model.append([content.get('loadt'),content.get('msg'),'#80FFFF'])
                xorg_color_flag = ~xorg_color_flag
        self.wTree.get_widget("treeview_xorg").set_model(model)

    def update_pagelabel(self, position ,total):
        page_count = total/self.items_one_page
        if total%self.items_one_page > 0:
            page_count += 1
        current_page = position/self.items_one_page
        if position%self.items_one_page > 0:
            current_page += 1
        self.wTree.get_widget("label_pagenum").set_text(_(str(current_page)+'/'+str(page_count)))

    def update_last_next_button(self, number ,count):
        if count > self.items_one_page:
            if number <= self.items_one_page:
                self.wTree.get_widget("button_lastpage").hide()
                self.wTree.get_widget("button_nextpage").show()
            elif number == count:
                self.wTree.get_widget("button_lastpage").show()
                self.wTree.get_widget("button_nextpage").hide()
            else:
                self.wTree.get_widget("button_lastpage").show()
                self.wTree.get_widget("button_nextpage").show()
        else:
            self.wTree.get_widget("button_nextpage").hide()
            self.wTree.get_widget("button_lastpage").hide()

    def update_year_month(self, year ,month):
        self.wTree.get_widget("combobox_year").set_active(year)
        self.wTree.get_widget("combobox_month").set_active(month)

    def update_keyword(self, keyword):
        key = self.wTree.get_widget("entry_keyword").set_text(keyword)

    '''get filter information'''
    def get_filter_info(self, list_filtered, year, month):
        list_ret = []
        if year == '0':
            if month == '0':
                list_ret = list_filtered[:]
            else:
                for line in list_filtered:
                    if(line.get('date').split('-')[1] == month):
                        list_ret.append(line)
        else:
            if month == '0':
                for line in list_filtered:
                    if(line.get('date').split('-')[0] == year):
                        list_ret.append(line)
            else:
                for line in list_filtered:
                    if(line.get('date').split('-')[0] == year and line.get('date').split('-')[1] == month):
                        list_ret.append(line)
        return list_ret

    '''change page by keyword'''
    def filter_statistics_callback(self, widget):
        key = self.wTree.get_widget("entry_keyword").get_text()
        year_index = self.wTree.get_widget("combobox_year").get_active()
        month_index = self.wTree.get_widget("combobox_month").get_active()
        if self.flag_menu == 0:
            active = self.wTree.get_widget("menu_view").get_active().get_label()
        else:
            active = self.wTree.get_widget("menu_analyze").get_active().get_label()
        month = str(month_index)
        if year_index == 0:
            year = '0'
        else:
            year = self.wtmp_year[year_index-1]
        tmp_count = 0
        tmp_number = 0
        #page for shutdown and reboot time
        if active == _("Last search"):
            del self.load_wtmp_list[:]
            self.keyword_wtmp = key
            #key == reboot
            if unicode(key,'utf8').find(u'\u5f00') != -1:
                key = 'reboot'
            #key == shutdown
            elif unicode(key,'utf8').find(u'\u5173') != -1:
                key = 'shutdown'
            #key == reboot and shutdown
            elif unicode(key,'utf8').find(u'\u673a') != -1:
                key = ''
            #update current item's start position and count for filterd list
            self.load_wtmp_list = self.get_filter_info(self.time_list, year, month)
            self.load_wtmp_list = self.check_parser.check_match_keywords(self.load_wtmp_list, key)
            self.count_for_wtmp = len(self.load_wtmp_list)
            self.number_for_wtmp = 0

            self.wTree.get_widget("treeview_all").get_model().clear()
            self.load_wtmp(f=1, start = 0, end = 0)
            tmp_count = self.count_for_wtmp
            tmp_number = self.number_for_wtmp
            self.year_for_wtmp = year_index
            self.month_for_wtmp = month_index
        #page for shutdown and reboot times
        elif active == _("Times statistics"):
            del self.load_times_list[:]
            self.keyword_times = key
            #update current item's start position and count for filterd list
            self.load_times_list = self.get_filter_info(self.times_for_years, year, month)
            self.load_times_list = self.check_parser.check_match_keywords(self.load_times_list, key)
            self.count_for_times = len(self.load_times_list)
            self.number_for_times = 0

            self.wTree.get_widget("treeview_times").get_model().clear()
            self.load_times(f=1, start = 0, end = 0)
            tmp_count = self.count_for_times
            tmp_number = self.number_for_times
            self.year_for_times = year_index
            self.month_for_times = month_index
        #page for dmesg
        elif active == _("Dmesg statistics"):
            del self.load_dmesg_list[:]
            self.keyword_dmesg = key
            #update current item's start position and count for filterd list
            self.load_dmesg_list = self.check_parser.check_match_keywords(self.dmesglist, key)
            self.count_for_dmesg = len(self.load_dmesg_list)
            self.number_for_dmesg = 0

            self.wTree.get_widget("treeview_dmesg").get_model().clear()
            self.load_dmesglist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_dmesg
            tmp_number = self.number_for_dmesg
        #page for auth
        elif active == _("Auth statistics"):
            del self.load_auth_list[:]
            self.keyword_auth = key
            #update current item's start position and count for filterd list
            self.load_auth_list = self.check_parser.check_match_keywords(self.authlist, key)
            self.count_for_auth = len(self.load_auth_list)
            self.number_for_auth = 0

            self.wTree.get_widget("treeview_auth").get_model().clear()
            self.load_authlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_auth
            tmp_number = self.number_for_auth
        #page for sys
        elif active == _("Sys statistics"):
            del self.load_sys_list[:]
            self.keyword_sys = key
            #update current item's start position and count for filterd list
            self.load_sys_list = self.check_parser.check_match_keywords(self.syslist, key)
            self.count_for_sys = len(self.load_sys_list)
            self.number_for_sys = 0

            self.wTree.get_widget("treeview_sys").get_model().clear()
            self.load_syslist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_sys
            tmp_number = self.number_for_sys
        #page for boot
        elif active == _("Boot statistics"):
            del self.load_boot_list[:]
            self.keyword_boot = key
            #update current item's start position and count for filterd list
            self.load_boot_list = self.check_parser.check_match_keywords(self.bootlist, key)
            self.count_for_boot = len(self.load_boot_list)
            self.number_for_boot = 0

            self.wTree.get_widget("treeview_boot").get_model().clear()
            self.load_bootlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_boot
            tmp_number = self.number_for_boot
        #page for dpkg
        elif active == _("Dpkg statistics"):
            del self.load_dpkg_list[:]
            self.keyword_dpkg = key
            #update current item's start position and count for filterd list
            self.load_dpkg_list = self.check_parser.check_match_keywords(self.dpkglist, key)
            self.count_for_dpkg = len(self.load_dpkg_list)
            self.number_for_dpkg = 0

            self.wTree.get_widget("treeview_dpkg").get_model().clear()
            self.load_dpkglist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_dpkg
            tmp_number = self.number_for_dpkg
        #page for kern
        elif active == _("Kern statistics"):
            del self.load_kern_list[:]
            self.keyword_kern = key
            #update current item's start position and count for filterd list
            self.load_kern_list = self.check_parser.check_match_keywords(self.kernlist, key)
            self.count_for_kern = len(self.load_kern_list)
            self.number_for_kern = 0

            self.wTree.get_widget("treeview_kern").get_model().clear()
            self.load_kernlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_kern
            tmp_number = self.number_for_kern
        #page for alter
        elif active == _("Alternative statistics"):
            del self.load_alter_list[:]
            self.keyword_alter = key
            #update current item's start position and count for filterd list
            self.load_alter_list = self.check_parser.check_match_keywords(self.alterlist, key)
            self.count_for_alter = len(self.load_alter_list)
            self.number_for_alter = 0

            self.wTree.get_widget("treeview_alter").get_model().clear()
            self.load_alterlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_alter
            tmp_number = self.number_for_alter
        #page for cups
        elif active == _("Cups statistics"):
            del self.load_cups_list[:]
            self.keyword_cups = key
            #update current item's start position and count for filterd list
            self.load_cups_list = self.check_parser.check_match_keywords(self.cupslist, key)
            self.count_for_cups = len(self.load_cups_list)
            self.number_for_cups = 0

            self.wTree.get_widget("treeview_cups").get_model().clear()
            self.load_cupslist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_cups
            tmp_number = self.number_for_cups
        #page for ufw
        elif active == _("Ufw statistics"):
            del self.load_ufw_list[:]
            self.keyword_ufw = key
            #update current item's start position and count for filterd list
            self.load_ufw_list = self.check_parser.check_match_keywords(self.ufwlist, key)
            self.count_for_ufw = len(self.load_ufw_list)
            self.number_for_ufw = 0

            self.wTree.get_widget("treeview_ufw").get_model().clear()
            self.load_ufwlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_ufw
            tmp_number = self.number_for_ufw
        #page for fail
        elif active == _("Fail statistics"):
            del self.load_fail_list[:]
            self.keyword_fail = key
            #update current item's start position and count for filterd list
            self.load_fail_list = self.check_parser.check_match_keywords(self.faillist, key)
            self.count_for_fail = len(self.load_fail_list)
            self.number_for_fail = 0

            self.wTree.get_widget("treeview_fail").get_model().clear()
            self.load_faillist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_fail
            tmp_number = self.number_for_fail
        #page for xorg
        elif active == _("Xorg statistics"):
            del self.load_xorg_list[:]
            self.keyword_xorg = key
            #update current item's start position and count for filterd list
            self.load_xorg_list = self.check_parser.check_match_keywords(self.xorglist, key)
            self.count_for_xorg = len(self.load_xorg_list)
            self.number_for_xorg = 0

            self.wTree.get_widget("treeview_xorg").get_model().clear()
            self.load_xorglist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_xorg
            tmp_number = self.number_for_xorg
        if active != _("Last search") and active != _("Times statistics"):
            self.wTree.get_widget("combobox_year").hide()
            self.wTree.get_widget("combobox_month").hide()
            self.wTree.get_widget("label_year").hide()
            self.wTree.get_widget("label_month").hide()
        else:
            self.wTree.get_widget("combobox_year").show()
            self.wTree.get_widget("combobox_month").show()
            self.wTree.get_widget("label_year").show()
            self.wTree.get_widget("label_month").show()

        self.update_last_next_button(tmp_number,tmp_count)
        self.update_pagelabel(tmp_number,tmp_count)

    '''jump to '''
    def jumppage_callback(self, widget):
        jumpto = self.wTree.get_widget("entry_page").get_text()
        if jumpto == '':
            return
        jumpto = string.atoi(jumpto)
        if self.flag_menu == 0:
            active = self.wTree.get_widget("menu_view").get_active().get_label()
        else:
            active = self.wTree.get_widget("menu_analyze").get_active().get_label()
        tmp_count = 0
        tmp_number = 0
        position = 0
        self.wTree.get_widget("entry_page").set_text('')
        #page for shutdown and reboot time
        if active == _("Last search"):
            #get page count
            page_count = self.count_for_wtmp/self.items_one_page
            if self.count_for_wtmp%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            #set position of current page 
            self.number_for_wtmp = position
            self.wTree.get_widget("treeview_all").get_model().clear()
            self.load_wtmp(f=1, start = position, end = 0)
            tmp_count = self.count_for_wtmp
            tmp_number = self.number_for_wtmp
        #page for shutdown and reboot times
        elif active == _("Times statistics"):
            #get page count
            page_count = self.count_for_times/self.items_one_page
            if self.count_for_times%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set position of current page 
            self.number_for_times = position
            self.wTree.get_widget("treeview_times").get_model().clear()
            self.load_times(f=1, start = position, end = 0)
            tmp_count = self.count_for_times
            tmp_number = self.number_for_times
        #page for dmesg
        elif active == _("Dmesg statistics"):
            #get page count
            page_count = self.count_for_dmesg/self.items_one_page
            if self.count_for_dmesg%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set end position of current page 
            self.number_for_dmesg = position
            self.wTree.get_widget("treeview_dmesg").get_model().clear()
            self.load_dmesglist(f=1, start = position, end = 0)
            tmp_count = self.count_for_dmesg
            tmp_number = self.number_for_dmesg
        #page for auth
        elif active == _("Auth statistics"):
            #get page count
            page_count = self.count_for_auth/self.items_one_page
            if self.count_for_auth%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set end position of current page 
            self.number_for_auth = position
            self.wTree.get_widget("treeview_auth").get_model().clear()
            self.load_authlist(f=1, start = position, end = 0)
            tmp_count = self.count_for_auth
            tmp_number = self.number_for_auth
        #page for sys
        elif active == _("Sys statistics"):
            #get page count
            page_count = self.count_for_sys/self.items_one_page
            if self.count_for_sys%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set end position of current page 
            self.number_for_sys = position
            self.wTree.get_widget("treeview_sys").get_model().clear()
            self.load_syslist(f=1, start = position, end = 0)
            tmp_count = self.count_for_sys
            tmp_number = self.number_for_sys
        #page for boot
        elif active == _("Boot statistics"):
            #get page count
            page_count = self.count_for_boot/self.items_one_page
            if self.count_for_boot%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set end position of current page 
            self.number_for_boot = position
            self.wTree.get_widget("treeview_boot").get_model().clear()
            self.load_bootlist(f=1, start = position, end = 0)
            tmp_count = self.count_for_boot
            tmp_number = self.number_for_boot
        #page for dpkg
        elif active == _("Dpkg statistics"):
            #get page count
            page_count = self.count_for_dpkg/self.items_one_page
            if self.count_for_dpkg%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set end position of current page 
            self.number_for_dpkg = position
            self.wTree.get_widget("treeview_dpkg").get_model().clear()
            self.load_dpkglist(f=1, start = position, end = 0)
            tmp_count = self.count_for_dpkg
            tmp_number = self.number_for_dpkg
        #page for kern
        elif active == _("Kern statistics"):
            #get page count
            page_count = self.count_for_kern/self.items_one_page
            if self.count_for_kern%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set end position of current page 
            self.number_for_kern = position
            self.wTree.get_widget("treeview_kern").get_model().clear()
            self.load_kernlist(f=1, start = position, end = 0)
            tmp_count = self.count_for_kern
            tmp_number = self.number_for_kern
        #page for alter
        elif active == _("Alternative statistics"):
            #get page count
            page_count = self.count_for_alter/self.items_one_page
            if self.count_for_alter%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set end position of current page 
            self.number_for_alter = position
            self.wTree.get_widget("treeview_alter").get_model().clear()
            self.load_alterlist(f=1, start = position, end = 0)
            tmp_count = self.count_for_alter
            tmp_number = self.number_for_alter
        #page for cups
        elif active == _("Cups statistics"):
            #get page count
            page_count = self.count_for_cups/self.items_one_page
            if self.count_for_cups%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set end position of current page 
            self.number_for_cups = position
            self.wTree.get_widget("treeview_cups").get_model().clear()
            self.load_cupslist(f=1, start = position, end = 0)
            tmp_count = self.count_for_cups
            tmp_number = self.number_for_cups
        #page for ufw
        elif active == _("Ufw statistics"):
            #get page count
            page_count = self.count_for_ufw/self.items_one_page
            if self.count_for_ufw%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set end position of current page 
            self.number_for_ufw = position
            self.wTree.get_widget("treeview_ufw").get_model().clear()
            self.load_ufwlist(f=1, start = position, end = 0)
            tmp_count = self.count_for_ufw
            tmp_number = self.number_for_ufw
        #page for fail
        elif active == _("Fail statistics"):
            #get page count
            page_count = self.count_for_fail/self.items_one_page
            if self.count_for_fail%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set end position of current page 
            self.number_for_fail = position
            self.wTree.get_widget("treeview_fail").get_model().clear()
            self.load_faillist(f=1, start = position, end = 0)
            tmp_count = self.count_for_fail
            tmp_number = self.number_for_fail
        #page for xorg
        elif active == _("Xorg statistics"):
            #get page count
            page_count = self.count_for_xorg/self.items_one_page
            if self.count_for_xorg%self.items_one_page > 0:
                page_count += 1
            #get position of start
            if jumpto <= page_count and jumpto > 0:
                position = (jumpto-1)*self.items_one_page
            elif jumpto <= 0:
                return
            elif jumpto > page_count:
                jumpto = page_count
                position = (jumpto-1)*self.items_one_page
            #set end position of current page 
            self.number_for_xorg = position
            self.wTree.get_widget("treeview_xorg").get_model().clear()
            self.load_xorglist(f=1, start = position, end = 0)
            tmp_count = self.count_for_xorg
            tmp_number = self.number_for_xorg
        self.update_last_next_button(tmp_number,tmp_count)
        self.update_pagelabel(tmp_number,tmp_count)
        return

    def last_callback(self, widget):
        if self.flag_menu == 0:
            active = self.wTree.get_widget("menu_view").get_active().get_label()
        else:
            active = self.wTree.get_widget("menu_analyze").get_active().get_label()
        tmp_count = 0
        tmp_number = 0
        #page for shutdown and reboot time
        if active == _("Last search"):
            self.twopage_count = self.twopage_count1
            self.items_one_page = self.item_count1
            mod = self.number_for_wtmp%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_wtmp - self.twopage_count
            else:
                tmp_number = self.number_for_wtmp - self.items_one_page -mod
            self.number_for_wtmp = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_all").get_model().clear()
            self.load_wtmp(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_wtmp
            tmp_number = self.number_for_wtmp
        #page for shutdown and reboot times
        elif active == _("Times statistics"):
            self.twopage_count = self.twopage_count1
            self.items_one_page = self.item_count1
            mod = self.number_for_times%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_times - self.twopage_count
            else:
                tmp_number = self.number_for_times - self.items_one_page -mod
            self.number_for_times = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_times").get_model().clear()
            self.load_times(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_times
            tmp_number = self.number_for_times
        #page for dmesg
        elif active == _("Dmesg statistics"):
            self.twopage_count = self.twopage_count1
            self.items_one_page = self.item_count1
            mod = self.number_for_dmesg%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_dmesg - self.twopage_count
            else:
                tmp_number = self.number_for_dmesg - self.items_one_page -mod
            self.number_for_dmesg = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_dmesg").get_model().clear()
            self.load_dmesglist(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_dmesg
            tmp_number = self.number_for_dmesg
        #page for auth
        elif active == _("Auth statistics"):
            self.twopage_count = self.twopage_count1
            self.items_one_page = self.item_count1
            mod = self.number_for_auth%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_auth - self.twopage_count
            else:
                tmp_number = self.number_for_auth - self.items_one_page -mod
            self.number_for_auth = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_auth").get_model().clear()
            self.load_authlist(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_auth
            tmp_number = self.number_for_auth
        #page for sys
        elif active == _("Sys statistics"):
            self.twopage_count = self.twopage_count1
            self.items_one_page = self.item_count1
            mod = self.number_for_sys%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_sys - self.twopage_count
            else:
                tmp_number = self.number_for_sys - self.items_one_page -mod
            self.number_for_sys = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_sys").get_model().clear()
            self.load_syslist(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_sys
            tmp_number = self.number_for_sys
        #page for boot
        elif active == _("Boot statistics"):
            self.twopage_count = self.twopage_count2
            self.items_one_page = self.item_count2
            mod = self.number_for_boot%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_boot - self.twopage_count
            else:
                tmp_number = self.number_for_boot - self.items_one_page -mod
            self.number_for_boot = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_boot").get_model().clear()
            self.load_bootlist(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_boot
            tmp_number = self.number_for_boot
        #page for dpkg
        elif active == _("Dpkg statistics"):
            self.twopage_count = self.twopage_count2
            self.items_one_page = self.item_count2
            mod = self.number_for_dpkg%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_dpkg - self.twopage_count
            else:
                tmp_number = self.number_for_dpkg - self.items_one_page -mod
            self.number_for_dpkg = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_dpkg").get_model().clear()
            self.load_dpkglist(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_dpkg
            tmp_number = self.number_for_dpkg
        #page for kern
        elif active == _("Kern statistics"):
            self.twopage_count = self.twopage_count1
            self.items_one_page = self.item_count1
            mod = self.number_for_kern%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_kern - self.twopage_count
            else:
                tmp_number = self.number_for_kern - self.items_one_page -mod
            self.number_for_kern = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_kern").get_model().clear()
            self.load_kernlist(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_kern
            tmp_number = self.number_for_kern
        #page for alter
        elif active == _("Alternative statistics"):
            self.twopage_count = self.twopage_count1
            self.items_one_page = self.item_count1
            mod = self.number_for_alter%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_alter - self.twopage_count
            else:
                tmp_number = self.number_for_alter - self.items_one_page -mod
            self.number_for_alter = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_alter").get_model().clear()
            self.load_alterlist(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_alter
            tmp_number = self.number_for_alter
        #page for cups
        elif active == _("Cups statistics"):
            self.twopage_count = self.twopage_count1
            self.items_one_page = self.item_count1
            mod = self.number_for_cups%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_cups - self.twopage_count
            else:
                tmp_number = self.number_for_cups - self.items_one_page -mod
            self.number_for_cups = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_cups").get_model().clear()
            self.load_cupslist(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_cups
            tmp_number = self.number_for_cups
        #page for ufw
        elif active == _("Ufw statistics"):
            self.twopage_count = self.twopage_count1
            self.items_one_page = self.item_count1
            mod = self.number_for_ufw%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_ufw - self.twopage_count
            else:
                tmp_number = self.number_for_ufw - self.items_one_page -mod
            self.number_for_ufw = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_ufw").get_model().clear()
            self.load_ufwlist(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_ufw
            tmp_number = self.number_for_ufw
        #page for fail
        elif active == _("Fail statistics"):
            self.twopage_count = self.twopage_count2
            self.items_one_page = self.item_count2
            mod = self.number_for_fail%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_fail - self.twopage_count
            else:
                tmp_number = self.number_for_fail - self.items_one_page -mod
            self.number_for_fail = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_fail").get_model().clear()
            self.load_faillist(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_fail
            tmp_number = self.number_for_fail
        #page for xorg
        elif active == _("Xorg statistics"):
            self.twopage_count = self.twopage_count1
            self.items_one_page = self.item_count1
            mod = self.number_for_xorg%self.items_one_page
            if mod == 0:
                tmp_number = self.number_for_xorg - self.twopage_count
            else:
                tmp_number = self.number_for_xorg - self.items_one_page -mod
            self.number_for_xorg = tmp_number + self.items_one_page
            self.wTree.get_widget("treeview_xorg").get_model().clear()
            self.load_xorglist(f=0, start = tmp_number, end = tmp_number + self.items_one_page)
            tmp_count = self.count_for_xorg
            tmp_number = self.number_for_xorg
        self.update_last_next_button(tmp_number,tmp_count)
        self.update_pagelabel(tmp_number,tmp_count)
    def next_callback(self, widget):
        if self.flag_menu == 0:
            active = self.wTree.get_widget("menu_view").get_active().get_label()
        else:
            active = self.wTree.get_widget("menu_analyze").get_active().get_label()
        tmp_count = 0
        tmp_number = 0
        #page for shutdown and reboot time
        if active == _("Last search"):
            self.items_one_page = self.item_count1
            tmp_number = self.number_for_wtmp
            self.wTree.get_widget("treeview_all").get_model().clear()
            self.load_wtmp(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_wtmp
            tmp_number = self.number_for_wtmp
        #page for shutdown and reboot times
        elif active == _("Times statistics"):
            self.items_one_page = self.item_count1
            tmp_number = self.number_for_times
            self.wTree.get_widget("treeview_times").get_model().clear()
            self.load_times(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_times
            tmp_number = self.number_for_times
        #page for dmesg
        elif active == _("Dmesg statistics"):
            self.items_one_page = self.item_count1
            tmp_number = self.number_for_dmesg
            self.wTree.get_widget("treeview_dmesg").get_model().clear()
            self.load_dmesglist(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_dmesg
            tmp_number = self.number_for_dmesg
        #page for auth
        elif active == _("Auth statistics"):
            self.items_one_page = self.item_count1
            tmp_number = self.number_for_auth
            self.wTree.get_widget("treeview_auth").get_model().clear()
            self.load_authlist(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_auth
            tmp_number = self.number_for_auth
        #page for sys
        elif active == _("Sys statistics"):
            self.items_one_page = self.item_count1
            tmp_number = self.number_for_sys
            self.wTree.get_widget("treeview_sys").get_model().clear()
            self.load_syslist(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_sys
            tmp_number = self.number_for_sys
        #page for boot
        elif active == _("Boot statistics"):
            self.items_one_page = self.item_count2
            tmp_number = self.number_for_boot
            self.wTree.get_widget("treeview_boot").get_model().clear()
            self.load_bootlist(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_boot
            tmp_number = self.number_for_boot
        #page for dpkg
        elif active == _("Dpkg statistics"):
            self.items_one_page = self.item_count2
            tmp_number = self.number_for_dpkg
            self.wTree.get_widget("treeview_dpkg").get_model().clear()
            self.load_dpkglist(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_dpkg
            tmp_number = self.number_for_dpkg
        #page for kern
        elif active == _("Kern statistics"):
            self.items_one_page = self.item_count1
            tmp_number = self.number_for_kern
            self.wTree.get_widget("treeview_kern").get_model().clear()
            self.load_kernlist(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_kern
            tmp_number = self.number_for_kern
        #page for alter
        elif active == _("Alternative statistics"):
            self.items_one_page = self.item_count1
            tmp_number = self.number_for_alter
            self.wTree.get_widget("treeview_alter").get_model().clear()
            self.load_alterlist(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_alter
            tmp_number = self.number_for_alter
        #page for cups
        elif active == _("Cups statistics"):
            self.items_one_page = self.item_count1
            tmp_number = self.number_for_cups
            self.wTree.get_widget("treeview_cups").get_model().clear()
            self.load_cupslist(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_cups
            tmp_number = self.number_for_cups
        #page for ufw
        elif active == _("Ufw statistics"):
            self.items_one_page = self.item_count1
            tmp_number = self.number_for_ufw
            self.wTree.get_widget("treeview_ufw").get_model().clear()
            self.load_ufwlist(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_ufw
            tmp_number = self.number_for_ufw
        #page for fail
        elif active == _("Fail statistics"):
            self.items_one_page = self.item_count2
            tmp_number = self.number_for_fail
            self.wTree.get_widget("treeview_fail").get_model().clear()
            self.load_faillist(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_fail
            tmp_number = self.number_for_fail
        #page for xorg
        elif active == _("Xorg statistics"):
            self.items_one_page = self.item_count1
            tmp_number = self.number_for_xorg
            self.wTree.get_widget("treeview_xorg").get_model().clear()
            self.load_xorglist(f=1, start = tmp_number, end = 0)
            tmp_count = self.count_for_xorg
            tmp_number = self.number_for_xorg
        self.update_last_next_button(tmp_number,tmp_count)
        self.update_pagelabel(tmp_number,tmp_count)

    '''change page'''
    def change_notebook(self, widget):
        active = widget.get_label()
        tmp_count = 0
        tmp_number = 0
        year = 0
        month = 0
        key = ''
        #page for shutdown and reboot time
        if active == _("Last search"):
            self.wTree.get_widget("notebook").set_current_page(0)
            self.flag_menu = 0
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("Last search"))
            tmp_count = self.count_for_wtmp
            tmp_number = self.number_for_wtmp
            year = self.year_for_wtmp
            month = self.month_for_wtmp
            key = self.keyword_wtmp
        #page for shutdown and reboot times
        elif active == _("Times statistics"):
            self.wTree.get_widget("notebook").set_current_page(1)
            self.flag_menu = 1
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("Times statistics"))
            tmp_count = self.count_for_times
            tmp_number = self.number_for_times
            year = self.year_for_times
            month = self.month_for_times
            key = self.keyword_times
        #page for dmesg
        elif active == _("Dmesg statistics"):
            self.wTree.get_widget("notebook").set_current_page(2)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Dmesg statistics"))
            self.items_one_page = self.item_count1
            if not self.load_dmesg_flag:
                self.load_dmesglist(1,start = tmp_number, end = 0)
                self.load_dmesg_flag = 1
            tmp_count = self.count_for_dmesg
            tmp_number = self.number_for_dmesg
            key = self.keyword_dmesg
        #page for auth
        elif active == _("Auth statistics"):
            self.wTree.get_widget("notebook").set_current_page(3)
            self.flag_menu = 0
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("Auth statistics"))
            if not self.load_auth_flag:
                self.load_authlist(1,start = tmp_number, end = 0)
                self.load_auth_flag = 1
            tmp_count = self.count_for_auth
            tmp_number = self.number_for_auth
            key = self.keyword_auth
        #page for sys
        elif active == _("Sys statistics"):
            self.wTree.get_widget("notebook").set_current_page(4)
            self.flag_menu = 0
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("Sys statistics"))
            if not self.load_sys_flag:
                self.load_syslist(1,start = tmp_number, end = 0)
                self.load_sys_flag = 1
            tmp_count = self.count_for_sys
            tmp_number = self.number_for_sys
            key = self.keyword_sys
        #page for boot
        elif active == _("Boot statistics"):
            self.wTree.get_widget("notebook").set_current_page(5)
            self.flag_menu = 0
            self.items_one_page = self.item_count2
            self.wTree.get_widget("label_logtitle").set_text(_("Boot statistics"))
            if not self.load_boot_flag:
                self.load_bootlist(1,start = tmp_number, end = 0)
                self.load_boot_flag = 1
            tmp_count = self.count_for_boot
            tmp_number = self.number_for_boot
            key = self.keyword_boot
        #page for dpkg
        elif active == _("Dpkg statistics"):
            self.wTree.get_widget("notebook").set_current_page(6)
            self.flag_menu = 0
            self.items_one_page = self.item_count2
            self.wTree.get_widget("label_logtitle").set_text(_("Dpkg statistics"))
            if not self.load_dpkg_flag:
                self.load_dpkglist(1,start = tmp_number, end = 0)
                self.load_dpkg_flag = 1
            tmp_count = self.count_for_dpkg
            tmp_number = self.number_for_dpkg
            key = self.keyword_dpkg
        #page for kern
        elif active == _("Kern statistics"):
            self.wTree.get_widget("notebook").set_current_page(7)
            self.flag_menu = 0
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("Kern statistics"))
            if not self.load_kern_flag:
                self.load_kernlist(1,start = tmp_number, end = 0)
                self.load_kern_flag = 1
            tmp_count = self.count_for_kern
            tmp_number = self.number_for_kern
            key = self.keyword_kern
        #page for alter
        elif active == _("Alternative statistics"):
            self.wTree.get_widget("notebook").set_current_page(8)
            self.flag_menu = 0
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("Alternative statistics"))
            if not self.load_alter_flag:
                self.load_alterlist(1,start = tmp_number, end = 0)
                self.load_alter_flag = 1
            tmp_count = self.count_for_alter
            tmp_number = self.number_for_alter
            key = self.keyword_alter
        #page for cups
        elif active == _("Cups statistics"):
            self.wTree.get_widget("notebook").set_current_page(9)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Cups statistics"))
            self.items_one_page = self.item_count1
            if not self.load_cups_flag:
                self.load_cupslist(1,start = tmp_number, end = 0)
                self.load_cups_flag = 1
            tmp_count = self.count_for_cups
            tmp_number = self.number_for_cups
            key = self.keyword_cups
        #page for ufw
        elif active == _("Ufw statistics"):
            self.wTree.get_widget("notebook").set_current_page(10)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Ufw statistics"))
            self.items_one_page = self.item_count1
            if not self.load_ufw_flag:
                self.load_ufwlist(1,start = tmp_number, end = 0)
                self.load_ufw_flag = 1
            tmp_count = self.count_for_ufw
            tmp_number = self.number_for_ufw
            key = self.keyword_ufw
        #page for fail
        elif active == _("Fail statistics"):
            self.wTree.get_widget("notebook").set_current_page(11)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Fail statistics"))
            self.items_one_page = self.item_count2
            if not self.load_fail_flag:
                self.load_faillist(1,start = tmp_number, end = 0)
                self.load_fail_flag = 1
            tmp_count = self.count_for_fail
            tmp_number = self.number_for_fail
            key = self.keyword_fail
        #page for xorg
        elif active == _("Xorg statistics"):
            self.wTree.get_widget("notebook").set_current_page(12)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Xorg statistics"))
            self.items_one_page = self.item_count1
            if not self.load_xorg_flag:
                self.load_xorglist(1,start = tmp_number, end = 0)
                self.load_xorg_flag = 1
            tmp_count = self.count_for_xorg
            tmp_number = self.number_for_xorg
            key = self.keyword_xorg
        if active != _("Last search") and active != _("Times statistics"):
            self.wTree.get_widget("combobox_year").hide()
            self.wTree.get_widget("combobox_month").hide()
            self.wTree.get_widget("label_year").hide()
            self.wTree.get_widget("label_month").hide()
        else:
            self.wTree.get_widget("combobox_year").show()
            self.wTree.get_widget("combobox_month").show()
            self.wTree.get_widget("label_year").show()
            self.wTree.get_widget("label_month").show()

        self.update_keyword(key)
        self.update_year_month(year ,month)
        self.update_last_next_button(tmp_number,tmp_count)
        self.update_pagelabel(tmp_number,tmp_count)

if __name__ == "__main__":
    gtk.gdk.threads_init()
    LPMT()
    gtk.main()
